#! /usr/bin/env python

from __future__ import division
from xmgrace_interface import grace_no_safe as grace


class GracePlot(object):
	def __init__(self, square_plot=0):
		self.g = grace()
		self.data_set_count = 0
		self.graph_count = 0

		if square_plot:
			for setting in ['view xmin 0.150000',
							'view xmax 0.850000',
							'view ymin 0.150000',
							'view ymax 0.850000']:
				# self.g.Command('g'+str(self.graph_count) +' '+ setting)
				self.g.Command(setting)

	def AddDataSetLists(self, x_list, y_list, name=''):
		"""
		x_list - a list of x-values for data points
		y_list - a list of y-values for data points

		obviously the x_list and y_list must be in the same order (i.e.
		   x_list[10] must be the x-value for the point for which y_list[10]
		   is the y-value)
		"""
		self.AddDataSetPairs(zip(x_list, y_list), name)

	def AddDataSetPairs(self, list_of_coords, name=''):
		"""
		list_of_coords - a list of (x,y) tuples
		"""
		g = self.g
		set_num = self.data_set_count
		set = 's' + str(set_num)
		graph_num = self.graph_count
		graph = 'g' + str(graph_num)
		gs = graph+'.'+set
		g.Command(' '.join((gs, 'legend', '"'+name+'"')))
		g.Command ('legend loctype world')
		g.Command ('legend 0,1.18')
		g.Command ('legend on')
		
		for x,y in list_of_coords:
			g.Command(' '.join((gs, 'point', str(x)+','+str(y))))
			
##		g.Command(' '.join((gs, 'symbol', str(set_num+1))))
##		g.Command(' '.join((gs, 'symbol size 0.4')))
##		g.Command(' '.join((gs, 'symbol fill pattern 0')))
		settings_list = ['symbol 0', 'line type 1', 'line linewidth 2.0',
						 'line pattern 1',
						 'line color '+ str(set_num),
						 'line linestyle '+ str(set_num)] 
		for setting in settings_list:
			g.Command(gs+' '+ setting)
		g.Command('autoscale')
		g.Command('redraw')
		g.Flush()
		self.data_set_count += 1

	def AddDataSetPairsString(self, list_of_coords, name='', color='', line='', symbol='0'):
		"""
		list_of_coords - a list of (x,y,string) tuples
		"""
		g = self.g
		set_num = self.data_set_count
		set = 's' + str(set_num)
		graph_num = self.graph_count
		graph = 'g' + str(graph_num)
		gs = graph+'.'+set
		g.Command(' '.join((gs, 'legend', '"'+name+'"')))
		g.Command ('legend loctype world')
		g.Command ('legend 0,1')
		g.Command ('legend on')
		
		for x,y, string in list_of_coords:
			g.Command(' '.join((gs, 'point', str(x)+','+str(y))))
			g.Command(gs + '.y1['+ gs + '.length - 1] = ' + string)

			## S0 POINT expr, expr
			## S0.Y1[S0.LENGTH - 1] = expr
			## S0.Y2[S0.LENGTH - 1] = expr

			

		if not color:
			color = str(set_num)
		if not line:
			line = str(set_num)
			
		settings_list = ['symbol '+symbol, 'line type 1', 'line linewidth 1.0',
						 'line pattern 1',
						 'line color '+ color,
						 'line linestyle '+ line] 
		for setting in settings_list:
			g.Command(gs+' '+ setting)
		g.Command('autoscale')
		g.Command('redraw')
		g.Flush()
		self.data_set_count += 1


	def AddDiagonal(self):
		g = self.g
		set_num = self.data_set_count
		set = 's' + str(set_num)
		graph_num = self.graph_count
		graph = 'g' + str(graph_num)
		gs = graph+'.'+set
		list_of_coords = ((0,0), (1,1))
		for x,y in list_of_coords:
			g.Command(' '.join((gs, 'point', str(x)+','+str(y))))

		settings_list = ['symbol 0', 'line type 1', 'line linestyle 1',
						 'line linewidth 1.5', 'line color 7', 'line pattern 1'] 
		for setting in settings_list:
			g.Command(gs+' '+ setting)
		g.Command('autoscale')
		g.Command('redraw')
		g.Flush()
		self.data_set_count += 1

	def XLabel(self, label):
		g = self.g
		g.Command(' '.join(("g" + str(self.graph_count), 'xaxis label', '"'+label+'"')))
		g.Command('redraw')
		g.Flush()

	def YLabel(self, label):
		g = self.g
		g.Command(' '.join(("g" + str(self.graph_count), 'yaxis label', '"'+label+'"')))
		g.Command('redraw')
		g.Flush()

	def Title(self, title):
		self.g.Command('title "' + title + '"')
		self.g.Command('redraw')
		self.g.Flush()

	def Subtitle(self, subtitle):
		self.g.Command('subtitle "' + subtitle + '"')
		self.g.Command('redraw')
		self.g.Flush()

	def Save(self, output_filename, device='postscript'):
		self.g.Command ('autoscale')
		self.g.Command ("page background fill off")
		self.g.Command ("redraw")
		self.g.Flush()

		if device.lower() == 'eps':
			device = device.upper()
			self.g.Command ('device "EPS" op "bbox:tight"')
			## print 'USING EPS'
		self.g.Command ('hardcopy device "%s"' % device)
		self.g.Command ('print to "%s"' % output_filename)
		self.g.Command ('print')
		self.g.Flush()


		

	def Exit(self):
		self.g.Command ('exit')
		self.g.Flush()
		self.g = None


"""
7.26 When I include an EPS file generated by Grace into my (La)TeX  document, the graphic hides some of the surrounding text.

LaTeX does not do hard clipping of EPS files unless instructed to do so. Use \includegraphics*{filename} and NOT \includegraphics{filename} (package graphics) or \includegraphics[clip]{filename} (package graphicx). If using the epsf package, remember to include the \epsfclipon flag (but note that the epsf package is obsolet and buggy and not maintained by the LaTeX team and in general should not be used).

The erasing comes about because Grace fills the background with the page size and not the bbox size. The background filling can be disabled from the "Plot/Plot appearance" popup.
"""
